﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Markup;
using Steema.TeeChart.WPF.Styles;
using Steema.TeeChart.WPF.Tools;
using Steema.TeeChart.WPF;
using Steema.TeeChart.WPF.Functions;


namespace WpfApplication2
{

    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            InitializeChart();
        }

        Points points;
        Steema.TeeChart.WPF.Styles.Line lineSeries;
        DownSampling downSampling;
        double[] ArrayX;
        double[] ArrayX1;
        List<double> listX;
        List<double> listX1;
        private void InitializeChart()
        {
            // InitializeList
            listX = new List<double>();
            listX1 = new List<double>();
            //InitializeChart
            tChart1.Axes.Bottom.Automatic = true;
            tChart1.Axes.Bottom.Labels.ValueFormat = string.Empty;
            tChart1.Aspect.View3D = false;
            tChart1.Legend.Visible = false;
            tChart1.Aspect.ClipPoints = true;
            // tChart1.Zoom.Allow = false;
            tChart1.Axes.Left.Automatic = true;
            tChart1.Zoom.Direction = ZoomDirections.Horizontal;
            //Create and InitializeSeries
            points = new Points(tChart1.Chart);
            lineSeries = new Steema.TeeChart.WPF.Styles.Line(tChart1.Chart);
            downSampling = new DownSampling(tChart1.Chart);
            //Points Series;
            points.DefaultNullValue = double.NegativeInfinity;
            points.ColorEach = true;
            var rnd = new Random();
            for (int index = 0; index < 50000; index++)
            {
                //for 1001 to 1999 make Colors.Transparent
                if (index > 1000 & index < 2000)
                    points.Add(index, rnd.Next(20, 30), Colors.Transparent);
                //for 5001 to 19999 make Colors.Black
                else if (index > 5000 & index < 20000)
                    points.Add(index, rnd.Next(10, 20), Colors.Black);
                //for rest make Colors.Red
                else
                    points.Add(index, rnd.Next(30, 40), Colors.Red);

            }
            //mark 1001 to 1999 as null
            for (var i = 0; i < 1000; i++)
            {
                points.SetNull(i + 1000);
            }
            points.Active = false;
            //Function DownSampling
            downSampling.DisplayedPointCount = 500;
            downSampling.Method = DownSamplingMethod.MinMaxFirstLastNull;
            //Line Series
            lineSeries.DefaultNullValue = double.NegativeInfinity;
            lineSeries.TreatNulls = TreatNullsStyle.DoNotPaint;
            lineSeries.Pointer.Visible = true;
            lineSeries.DataSource = points;
            lineSeries.Function = downSampling;
            lineSeries.LinePen.Width = 2;
            //PopulateList        
            Populate(listX, listX1);
            //Assign List Array to ArrayX and ArrayX1.
            ArrayX = listX.ToArray();
            ArrayX1 = listX1.ToArray();
            lineSeries.GetPointerStyle += new CustomPoint.GetPointerStyleEventHandler(lineSeries_GetPointerStyle);
            tChart1.AfterDraw += new PaintChartEventHandler(tChart1_AfterDraw);
            var bitmap = tChart1.Chart.Bitmap(tChart1.Width, tChart1.Height);
        }

        void tChart1_AfterDraw(object sender, Steema.TeeChart.WPF.Drawing.Graphics3D g)
        {
            if (tChart1[1] is Steema.TeeChart.WPF.Styles.Line)
            {
                Steema.TeeChart.WPF.Styles.Line series = tChart1[1] as Steema.TeeChart.WPF.Styles.Line;
                for (int index = 0; index < series.Count; index++)
                {
                    if (series.XValues[index] > points.XValues[1001] && series.XValues[index] < points.XValues[1999])
                    {
                        series[index].Color = Colors.Red;
                    }
                    else if (series.XValues[index] > points.XValues[5001] && series.XValues[index] < points.XValues[19999])
                    {
                        series[index].Color = Colors.Black;
                    }
                    else
                    {
                        series[index].Color = Colors.Orange;
                    }
                }
            }
        }
        private void Populate(List<double> list1, List<double> list2)
        {
            if (tChart1[1] is Steema.TeeChart.WPF.Styles.Line)
            {
                Steema.TeeChart.WPF.Styles.Line auxLine = (tChart1[1] as Steema.TeeChart.WPF.Styles.Line);
                for (int i = 0; i < auxLine.Count; i++)
                {

                    if ((tChart1[1].XValues[i] > points.XValues[1001] && tChart1[1].XValues[i] < points.XValues[1999]))
                    {
                        list1.Add(tChart1[1].XValues[i]);

                    }
                    else if (tChart1[1].XValues[i] > points.XValues[5001] && tChart1[1].XValues[i] < points.XValues[19999])
                    {
                        list2.Add(tChart1[1].XValues[i]);

                    }
                }
            }
        }

        void lineSeries_GetPointerStyle(CustomPoint series, GetPointerStyleEventArgs e)
        {
            if (series.XValues[e.ValueIndex] > points.XValues[1001] && series.XValues[e.ValueIndex] < points.XValues[1999])
            {
                for (int i = 0; i < ArrayX.Length; i++)
                {
                    if (series.XValues[e.ValueIndex].Equals(ArrayX[i]) || series.XValues[e.ValueIndex].Equals(ArrayX[i]))
                    {
                        if (series.XValues[e.ValueIndex].Equals(FindMinimum(ArrayX)) || series.XValues[e.ValueIndex].Equals(FindMaximum(ArrayX)))
                        {
                            e.Color = Colors.Red;
                            series.Pointer.Pen.Color = e.Color;
                            e.Style = PointerStyles.Circle;
                        }
                        else
                        {
                            e.Color = Colors.Transparent;
                            series.Pointer.Pen.Color = e.Color;
                        }
                    }
                }
            }
            else if (series.XValues[e.ValueIndex] > points.XValues[5001] && series.XValues[e.ValueIndex] < points.XValues[19999])
            {
                for (int i = 0; i < ArrayX1.Length; i++)
                {
                    if (series.XValues[e.ValueIndex].Equals(ArrayX1[i]) || series.XValues[e.ValueIndex].Equals(ArrayX1[i]))
                    {
                        if (series.XValues[e.ValueIndex].Equals(FindMaximum(ArrayX1)) || series.XValues[e.ValueIndex].Equals(FindMinimum(ArrayX1)))
                        {
                            e.Color = Colors.Black;
                            series.Pointer.Pen.Color = e.Color;
                            e.Style = PointerStyles.Circle;
                        }
                        else
                        {
                            e.Color = Colors.Transparent;
                            series.Pointer.Pen.Color = e.Color;
                        }
                    }
                }
            }
            else
            {
                e.Color = Colors.Transparent;
                series.Pointer.Pen.Color = e.Color;
                e.Style = PointerStyles.Circle;
            }
        }

        //Find Minimum Value
        private double FindMinimum(double[] array)
        {
            double Min = -1;
            for (int i = 0; i < array.Length; i++)
            {

                if (Min > array[i])
                {
                    Min = array[i];
                }
                else
                {
                    Min = array[0];
                }
            }
            return Min;
        }
        //Find Maximum value
        private double FindMaximum(double[] array)
        {
            double Max = -1;
            for (int i = 0; i < array.Length; i++)
            {
                if (Max < array[i])
                {
                    Max = array[i];
                }
                else
                {
                    Max = array[array.Length - 1];
                }
            }
            return Max;
        }
    }
}
  